/*=========================================================================

Program:   Visualization Toolkit
Module:    vtkBinaryBranchCountingImageFilter.cxx

Copyright (c) Xiaojie Zhao
All rights reserved.

This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#include "vtkBinaryBranchCountingImageFilter.h"

#include "vtkObjectFactory.h"
#include "vtkImageExport.h"
#include "vtkImageImport.h"
#include "vtkImageData.h"
#include "vtkInformationVector.h"
#include "vtkInformation.h"

vtkStandardNewMacro(vtkBinaryBranchCountingImageFilter);

//----------------------------------------------------------------------------
vtkBinaryBranchCountingImageFilter::vtkBinaryBranchCountingImageFilter()
{
	// Set up number of input and output ports

	// Initialize the ITK-VTK glue.
	this->Init();

	// Set up the internal filter pipeline.
	this->BinaryBranchCountingImageFilter = ITKBinaryBranchCountingImageFilterType::New();

	// Set the first and last filters in the internal ITK pipeline.
	this->SetITKPipelineFirstFilter<ITKInternalFilterType>(this->BinaryBranchCountingImageFilter);
	this->SetITKPipelineLastFilter<ITKInternalFilterType>(this->BinaryBranchCountingImageFilter);
}

//----------------------------------------------------------------------------
vtkBinaryBranchCountingImageFilter::~vtkBinaryBranchCountingImageFilter()
{
}

//----------------------------------------------------------------------------
int vtkBinaryBranchCountingImageFilter::UpdateInternalFilters()
{

	this->BinaryBranchCountingImageFilter->SetHandleBoundaryRadius( HandleBoundaryRadius );
	this->BinaryBranchCountingImageFilter->SetBranchCombineRadius( BranchCombineRadius );
	this->BinaryBranchCountingImageFilter->Update();

	return 1;
}

//----------------------------------------------------------------------------
void vtkBinaryBranchCountingImageFilter::PrintSelf(ostream& os, vtkIndent indent)
{
	this->Superclass::PrintSelf(os,indent);
}
