/*=========================================================================

Program:   Visualization Toolkit
Module:    vtkBinaryPruningImageFilter3D.cxx

Copyright (c) Xiaojie Zhao
All rights reserved.

This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#include "vtkBinaryPruningImageFilter3D.h"

#include "vtkObjectFactory.h"
#include "vtkImageExport.h"
#include "vtkImageImport.h"
#include "vtkImageData.h"
#include "vtkInformationVector.h"
#include "vtkInformation.h"

vtkStandardNewMacro(vtkBinaryPruningImageFilter3D);

//----------------------------------------------------------------------------
vtkBinaryPruningImageFilter3D::vtkBinaryPruningImageFilter3D()
{
	// Set up number of input and output ports

	// Initialize the ITK-VTK glue.
	this->Init();

	// Set up the internal filter pipeline.
	this->BinaryPruningImageFilter3D = ITKBinaryPruningImageFilter3DType::New();

	// Set the first and last filters in the internal ITK pipeline.
	this->SetITKPipelineFirstFilter<ITKInternalFilterType>(this->BinaryPruningImageFilter3D);
	this->SetITKPipelineLastFilter<ITKInternalFilterType>(this->BinaryPruningImageFilter3D);
}

//----------------------------------------------------------------------------
vtkBinaryPruningImageFilter3D::~vtkBinaryPruningImageFilter3D()
{
}

//----------------------------------------------------------------------------
int vtkBinaryPruningImageFilter3D::UpdateInternalFilters()
{
	this->BinaryPruningImageFilter3D->SetIteration( Iteration );
	this->BinaryPruningImageFilter3D->Update();

	return 1;
}

//----------------------------------------------------------------------------
void vtkBinaryPruningImageFilter3D::PrintSelf(ostream& os, vtkIndent indent)
{
	this->Superclass::PrintSelf(os,indent);
}
