/*=========================================================================

Program:   Visualization Toolkit
Module:    vtkBinaryThinningImageFilter3D.cxx

Copyright (c) Xiaojie Zhao
All rights reserved.

This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#include "vtkBinaryThinningImageFilter3D.h"

#include "vtkObjectFactory.h"
#include "vtkImageExport.h"
#include "vtkImageImport.h"
#include "vtkImageData.h"
#include "vtkInformationVector.h"
#include "vtkInformation.h"

vtkStandardNewMacro(vtkBinaryThinningImageFilter3D);

//----------------------------------------------------------------------------
vtkBinaryThinningImageFilter3D::vtkBinaryThinningImageFilter3D()
{
	// Set up number of input and output ports

	// Initialize the ITK-VTK glue.
	this->Init();

	// Set up the internal filter pipeline.
	this->BinaryThinningFilter3D = ITKBinaryThinningFilter3DType::New();

	// Set the first and last filters in the internal ITK pipeline.
	this->SetITKPipelineFirstFilter<ITKInternalFilterType>(this->BinaryThinningFilter3D);
	this->SetITKPipelineLastFilter<ITKInternalFilterType>(this->BinaryThinningFilter3D);
}

//----------------------------------------------------------------------------
vtkBinaryThinningImageFilter3D::~vtkBinaryThinningImageFilter3D()
{
}

//----------------------------------------------------------------------------
int vtkBinaryThinningImageFilter3D::UpdateInternalFilters()
{

	this->BinaryThinningFilter3D->Update();

	return 1;
}

//----------------------------------------------------------------------------
void vtkBinaryThinningImageFilter3D::PrintSelf(ostream& os, vtkIndent indent)
{
	this->Superclass::PrintSelf(os,indent);
}
