#ifndef __vtkContourWithPreviewFilter_h
#define __vtkContourWithPreviewFilter_h

#include "vtkImageAlgorithm.h"
#include "vtkImageThreshold.h"

class VTK_EXPORT vtkContourWithPreviewFilter : public vtkImageAlgorithm
{
public:
  static vtkContourWithPreviewFilter* New();
  vtkTypeMacro(vtkContourWithPreviewFilter, vtkImageAlgorithm);
  void PrintSelf(ostream& os, vtkIndent indent);

  vtkSetMacro(isovalue, double);
  vtkGetMacro(isovalue, double);

protected:
  vtkContourWithPreviewFilter();
  ~vtkContourWithPreviewFilter();

  int RequestData(vtkInformation *, vtkInformationVector **, vtkInformationVector *);

  double isovalue;
  bool   ifInit;
  bool   autoApplyBefore;
  vtkImageThreshold *thresholdFilter;
  
private:
  vtkContourWithPreviewFilter(const vtkContourWithPreviewFilter&);  // Not implemented.
  void operator=(const vtkContourWithPreviewFilter&);  // Not implemented.
};

#endif
