/*=========================================================================

Program:   Visualization Toolkit
Module:    vtkDanielssonDistanceMapImageFilter.cxx

Copyright (c) Xiaojie Zhao
All rights reserved.

This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notice for more information.

=========================================================================*/
#include "vtkDanielssonDistanceMapImageFilter.h"

#include "vtkObjectFactory.h"
#include "vtkImageExport.h"
#include "vtkImageImport.h"
#include "vtkImageData.h"
#include "vtkInformationVector.h"
#include "vtkInformation.h"

vtkStandardNewMacro(vtkDanielssonDistanceMapImageFilter);

//----------------------------------------------------------------------------
vtkDanielssonDistanceMapImageFilter::vtkDanielssonDistanceMapImageFilter()
{
	// Set up number of input and output ports

	// Initialize the ITK-VTK glue.
	this->Init();

	// Set up the internal filter pipeline.
	this->DanielssonDistanceMapFilter = ITKDanielssonDistanceMapFilterType::New();

	// Set the first and last filters in the internal ITK pipeline.
	this->SetITKPipelineFirstFilter<ITKInternalFilterType>(this->DanielssonDistanceMapFilter);
	this->SetITKPipelineLastFilter<ITKInternalFilterType>(this->DanielssonDistanceMapFilter);
}

//----------------------------------------------------------------------------
vtkDanielssonDistanceMapImageFilter::~vtkDanielssonDistanceMapImageFilter()
{
}

//----------------------------------------------------------------------------
int vtkDanielssonDistanceMapImageFilter::UpdateInternalFilters()
{
	this->DanielssonDistanceMapFilter->Update();

	return 1;
}

//----------------------------------------------------------------------------
void vtkDanielssonDistanceMapImageFilter::PrintSelf(ostream& os, vtkIndent indent)
{
	this->Superclass::PrintSelf(os,indent);
}
