#ifndef __vtkTiffVolumeReader_h
#define __vtkTiffVolumeReader_h

#include "vtkTIFFReader.h"
#include "vtkImageChangeInformation.h"
#include "vtkInformationVector.h"
#include "vtkImageData.h"
#include "vtkInformation.h"

class VTK_EXPORT vtkTiffVolumeReader : public vtkTIFFReader
{
public:
  static vtkTiffVolumeReader* New();
  
  vtkTypeMacro(vtkTiffVolumeReader, vtkTIFFReader);

  // Description:
  // Methods exposed to the server manager via proxy
  virtual void AddFileName(const char* fname);
  virtual void RemoveAllFileNames();
  virtual unsigned int GetNumberOfFileNames();
  virtual const char* GetFileName(unsigned int idx);
  virtual int RequestData(vtkInformation*, vtkInformationVector**, vtkInformationVector*);

  vtkSetVector3Macro(xyz_spacing, double);
  vtkGetVector3Macro(xyz_spacing, double);

protected:
  vtkImageChangeInformation* spacing_filter;
  double xyz_spacing[3];

  vtkTiffVolumeReader();
  virtual ~vtkTiffVolumeReader();   

};

#endif